"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueryList = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireWildcard(require("react"));
var _createStylingFromTheme = require("../styles/createStylingFromTheme");
var _rtkQuery = require("../utils/rtk-query");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
class QueryList extends _react.PureComponent {
  static isItemSelected(selectedQueryKey, queryInfo) {
    return !!selectedQueryKey && selectedQueryKey.queryKey === queryInfo.queryKey && selectedQueryKey.reducerPath === queryInfo.reducerPath;
  }
  static formatQuery(resInfo) {
    const key = resInfo.type === 'query' ? resInfo.queryKey : `${resInfo.state.endpointName ?? ''} ${resInfo.queryKey}`;
    return key;
  }
  render() {
    const {
      resInfos,
      selectedQueryKey,
      onSelectQuery
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_createStylingFromTheme.StyleUtilsContext.Consumer, null, _ref => {
      let {
        styling
      } = _ref;
      return /*#__PURE__*/_react.default.createElement("ul", styling('queryList'), resInfos.map(resInfo => {
        const isSelected = (0, _rtkQuery.isQuerySelected)(selectedQueryKey, resInfo);
        return /*#__PURE__*/_react.default.createElement("li", (0, _extends2.default)({
          key: resInfo.queryKey,
          onClick: () => onSelectQuery(resInfo)
        }, styling(['queryListItem', isSelected && 'queryListItemSelected'], isSelected)), /*#__PURE__*/_react.default.createElement("p", styling('queryListItemKey'), QueryList.formatQuery(resInfo)), /*#__PURE__*/_react.default.createElement("div", styling('queryStatusWrapper'), /*#__PURE__*/_react.default.createElement("strong", styling(['queryStatus', 'queryType']), resInfo.type === 'query' ? 'Q' : 'M'), /*#__PURE__*/_react.default.createElement("p", styling('queryStatus'), resInfo.state.status)));
      }));
    });
  }
}
exports.QueryList = QueryList;