"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.QueryPreviewHeader = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _react = _interopRequireDefault(require("react"));
var _createStylingFromTheme = require("../styles/createStylingFromTheme");
var _a11y = require("../utils/a11y");
var _object = require("../utils/object");
class QueryPreviewHeader extends _react.default.Component {
  handleTabClick = tab => {
    if (this.props.selectedTab !== tab.value) {
      this.props.onTabChange(tab.value);
    }
  };
  render() {
    const {
      tabs,
      selectedTab,
      renderTabLabel
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_createStylingFromTheme.StyleUtilsContext.Consumer, null, _ref => {
      let {
        styling
      } = _ref;
      return /*#__PURE__*/_react.default.createElement("div", styling('previewHeader'), /*#__PURE__*/_react.default.createElement("div", styling('tabSelector'), tabs.map(tab => /*#__PURE__*/_react.default.createElement("button", (0, _extends2.default)({
        type: "button",
        id: (0, _a11y.renderTabPanelButtonId)(tab.value),
        "aria-selected": tab.value === selectedTab,
        role: 'tab',
        onClick: () => this.handleTabClick(tab),
        key: tab.value
      }, styling(['selectorButton', tab.value === selectedTab && 'selectorButtonSelected'], tab.value === selectedTab)), /*#__PURE__*/_react.default.createElement("span", null, renderTabLabel ? renderTabLabel(tab) : tab.label)))));
    });
  }
  static defaultProps = {
    tabs: _object.emptyArray
  };
}
exports.QueryPreviewHeader = QueryPreviewHeader;