"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TreeView = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _toolkit = require("@reduxjs/toolkit");
var _react = _interopRequireDefault(require("react"));
var _reactJsonTree = require("react-json-tree");
var _monitorConfig = require("../monitor-config");
var _createStylingFromTheme = require("../styles/createStylingFromTheme");
var _tree = require("../styles/tree");
var _object = require("../utils/object");
class TreeView extends _react.default.PureComponent {
  static defaultProps = {
    hideRoot: true,
    shouldExpandNodeInitially: (keyPath, value, layer) => {
      return layer < 2;
    }
  };
  selectLabelRenderer = (0, _toolkit.createSelector)(_object.identity, _tree.createTreeItemLabelRenderer);
  selectGetItemString = (0, _toolkit.createSelector)(_object.identity, styling => (type, data) => (0, _tree.getItemString)(styling, type, data, _monitorConfig.DATA_TYPE_KEY, false));
  selectTheme = (0, _toolkit.createSelector)(_object.identity, _createStylingFromTheme.getJsonTreeTheme);
  constructor(props) {
    super(props);
  }
  render() {
    const {
      data,
      before,
      after,
      children,
      keyPath,
      shouldExpandNodeInitially,
      hideRoot,
      rootProps
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_createStylingFromTheme.StyleUtilsContext.Consumer, null, _ref => {
      let {
        styling,
        invertTheme,
        base16Theme
      } = _ref;
      return /*#__PURE__*/_react.default.createElement("div", (0, _extends2.default)({}, rootProps, styling('treeWrapper')), before, /*#__PURE__*/_react.default.createElement(_reactJsonTree.JSONTree, {
        keyPath: keyPath,
        shouldExpandNodeInitially: shouldExpandNodeInitially,
        data: data,
        labelRenderer: this.selectLabelRenderer(styling),
        theme: this.selectTheme(base16Theme),
        invertTheme: invertTheme,
        getItemString: this.selectGetItemString(styling),
        hideRoot: hideRoot
      }), after, children);
    });
  }
}
exports.TreeView = TreeView;