"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _RtkQueryInspector = _interopRequireDefault(require("./RtkQueryInspector"));
var _reducers = require("../reducers");
var _createStylingFromTheme = require("../styles/createStylingFromTheme");
function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function (e) { return e ? t : r; })(e); }
function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != typeof e && "function" != typeof e) return { default: e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && Object.prototype.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n.default = e, t && t.set(e, n), n; }
class RtkQueryMonitor extends _react.Component {
  static update = _reducers.reducer;
  static propTypes = {
    dispatch: _propTypes.default.func,
    computedStates: _propTypes.default.array,
    currentStateIndex: _propTypes.default.number,
    actionsById: _propTypes.default.object,
    stagedActionIds: _propTypes.default.array,
    skippedActionIds: _propTypes.default.array,
    monitorState: _propTypes.default.object,
    theme: _propTypes.default.oneOfType([_propTypes.default.object, _propTypes.default.string]),
    invertTheme: _propTypes.default.bool
  };
  static defaultProps = {
    theme: 'nicinabox',
    invertTheme: false
  };
  constructor(props) {
    super(props);
    this.state = {
      styleUtils: (0, _createStylingFromTheme.createThemeState)(props)
    };
  }
  render() {
    const {
      currentStateIndex,
      computedStates,
      monitorState,
      dispatch,
      actionsById
    } = this.props;
    return /*#__PURE__*/_react.default.createElement(_createStylingFromTheme.StyleUtilsContext.Provider, {
      value: this.state.styleUtils
    }, /*#__PURE__*/_react.default.createElement(_RtkQueryInspector.default, {
      computedStates: computedStates,
      currentStateIndex: currentStateIndex,
      monitorState: monitorState,
      dispatch: dispatch,
      styleUtils: this.state.styleUtils,
      actionsById: actionsById
    }));
  }
}
var _default = exports.default = RtkQueryMonitor;