import _extends from "@babel/runtime/helpers/extends";
import React, { PureComponent } from 'react';
import { StyleUtilsContext } from '../styles/createStylingFromTheme';
import { isQuerySelected } from '../utils/rtk-query';
export class QueryList extends PureComponent {
  static isItemSelected(selectedQueryKey, queryInfo) {
    return !!selectedQueryKey && selectedQueryKey.queryKey === queryInfo.queryKey && selectedQueryKey.reducerPath === queryInfo.reducerPath;
  }
  static formatQuery(resInfo) {
    const key = resInfo.type === 'query' ? resInfo.queryKey : `${resInfo.state.endpointName ?? ''} ${resInfo.queryKey}`;
    return key;
  }
  render() {
    const {
      resInfos,
      selectedQueryKey,
      onSelectQuery
    } = this.props;
    return /*#__PURE__*/React.createElement(StyleUtilsContext.Consumer, null, _ref => {
      let {
        styling
      } = _ref;
      return /*#__PURE__*/React.createElement("ul", styling('queryList'), resInfos.map(resInfo => {
        const isSelected = isQuerySelected(selectedQueryKey, resInfo);
        return /*#__PURE__*/React.createElement("li", _extends({
          key: resInfo.queryKey,
          onClick: () => onSelectQuery(resInfo)
        }, styling(['queryListItem', isSelected && 'queryListItemSelected'], isSelected)), /*#__PURE__*/React.createElement("p", styling('queryListItemKey'), QueryList.formatQuery(resInfo)), /*#__PURE__*/React.createElement("div", styling('queryStatusWrapper'), /*#__PURE__*/React.createElement("strong", styling(['queryStatus', 'queryType']), resInfo.type === 'query' ? 'Q' : 'M'), /*#__PURE__*/React.createElement("p", styling('queryStatus'), resInfo.state.status)));
      }));
    });
  }
}