import _extends from "@babel/runtime/helpers/extends";
import React from 'react';
import { StyleUtilsContext } from '../styles/createStylingFromTheme';
import { renderTabPanelButtonId } from '../utils/a11y';
import { emptyArray } from '../utils/object';
export class QueryPreviewHeader extends React.Component {
  handleTabClick = tab => {
    if (this.props.selectedTab !== tab.value) {
      this.props.onTabChange(tab.value);
    }
  };
  render() {
    const {
      tabs,
      selectedTab,
      renderTabLabel
    } = this.props;
    return /*#__PURE__*/React.createElement(StyleUtilsContext.Consumer, null, _ref => {
      let {
        styling
      } = _ref;
      return /*#__PURE__*/React.createElement("div", styling('previewHeader'), /*#__PURE__*/React.createElement("div", styling('tabSelector'), tabs.map(tab => /*#__PURE__*/React.createElement("button", _extends({
        type: "button",
        id: renderTabPanelButtonId(tab.value),
        "aria-selected": tab.value === selectedTab,
        role: 'tab',
        onClick: () => this.handleTabClick(tab),
        key: tab.value
      }, styling(['selectorButton', tab.value === selectedTab && 'selectorButtonSelected'], tab.value === selectedTab)), /*#__PURE__*/React.createElement("span", null, renderTabLabel ? renderTabLabel(tab) : tab.label)))));
    });
  }
  static defaultProps = {
    tabs: emptyArray
  };
}