import React, { PureComponent } from 'react';
import { QueryPreviewTabs } from '../types';
import { renderTabPanelButtonId, renderTabPanelId } from '../utils/a11y';
import { TreeView } from './TreeView';
const rootProps = {
  'aria-labelledby': renderTabPanelButtonId(QueryPreviewTabs.queryTags),
  id: renderTabPanelId(QueryPreviewTabs.queryTags),
  role: 'tabpanel'
};
export class QueryPreviewTags extends PureComponent {
  constructor(props) {
    super(props);
    this.state = {
      data: {
        tags: props.tags
      }
    };
  }
  render() {
    const {
      isWideLayout,
      tags
    } = this.props;
    return /*#__PURE__*/React.createElement(TreeView, {
      rootProps: rootProps,
      data: tags,
      isWideLayout: isWideLayout
    });
  }
}