import React, { Component } from 'react';
import PropTypes from 'prop-types';
import RtkQueryInspector from './RtkQueryInspector';
import { reducer } from '../reducers';
import { createThemeState, StyleUtilsContext } from '../styles/createStylingFromTheme';
class RtkQueryMonitor extends Component {
  static update = reducer;
  static propTypes = {
    dispatch: PropTypes.func,
    computedStates: PropTypes.array,
    currentStateIndex: PropTypes.number,
    actionsById: PropTypes.object,
    stagedActionIds: PropTypes.array,
    skippedActionIds: PropTypes.array,
    monitorState: PropTypes.object,
    theme: PropTypes.oneOfType([PropTypes.object, PropTypes.string]),
    invertTheme: PropTypes.bool
  };
  static defaultProps = {
    theme: 'nicinabox',
    invertTheme: false
  };
  constructor(props) {
    super(props);
    this.state = {
      styleUtils: createThemeState(props)
    };
  }
  render() {
    const {
      currentStateIndex,
      computedStates,
      monitorState,
      dispatch,
      actionsById
    } = this.props;
    return /*#__PURE__*/React.createElement(StyleUtilsContext.Provider, {
      value: this.state.styleUtils
    }, /*#__PURE__*/React.createElement(RtkQueryInspector, {
      computedStates: computedStates,
      currentStateIndex: currentStateIndex,
      monitorState: monitorState,
      dispatch: dispatch,
      styleUtils: this.state.styleUtils,
      actionsById: actionsById
    }));
  }
}
export default RtkQueryMonitor;